#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n,q;
    cin>>n>>q;
    int a[n];
    for(int i = 0;i<n;i++){
        cin>>a[i];
    }
    while(q--){
        int t,l,r;
        cin>>t>>l>>r;
        int len = r+l-1;
        if(a[l] == -1){
            len--;
        }
        if(a[r] == -1){
            len--;
        }
        if(l == r){
            cout<<0;
        }
        else{
            cout<<len;
        }
        cout<<endl;
    }
}
